#include <bits/stdc++.h>
using namespace std;

int n{ };
map<string, int> M;
vector<pair<int, int>> edges;
vector<vector<int>> G;
vector<bool> visited;
vector<int> S, wrank;

void dfs_visit(int v)
{
  visited[v] = true;
  for(int x : G[v])
    if(!visited[x])
      dfs_visit(x);
  wrank[v] = S.size();
  S.push_back(v);
}

bool cycles()
{
  for(int v=1; v<=n; v++)
  {  //cout << v << endl;
    for(int x : G[v])
    {
      //cout << v << '>' << x << endl;
      //cout << wrank[v] << ' ' << wrank[x] << endl;
      if(wrank[x] > wrank[v]) return true; // krawędź powrotna
    }
  }
  return false;
}

bool gaps()
{
  for(int r=n-1; r>0; r--)
  {
    int v = S[r], w = S[r-1];
    // czy w jest na liście sąsiedztwa v
    auto p = find(G[v].begin(), G[v].end(), w);
    if(p == G[v].end()) return true;
  }
  return false;
}

int main()
{
  int m;
  cin >> m;
  edges.resize(m);
  for(int i=0; i<m; i++)
  {
    string sa, sb; cin >> sa >> sb;
    int a, b;
    if(M.count(sa) > 0)
      a = M[sa];
    else
    {
      a = ++n; M[sa] = a;
    }
    if(M.count(sb) > 0)
      b = M[sb];
    else
    {
      b = ++n; M[sb] = b;
    }
    edges[i] = {a, b};
  }
  G.resize(n+1);
  visited.resize(n+1);
  wrank.resize(n+1, -1);
  for(auto p : edges)
    G[p.first].push_back(p.second);
  for(int v=1; v<=n; v++)
    if(!visited[v])
      dfs_visit(v);
//  for(int i=0; i<n; i++)
//    cout << S[i] << "/" << wrank[S[i]] << ' ';
//  cout << endl;
  if(cycles())
    cout << "NIE\n";
  else if(gaps())
    cout << "???\n";
  else
    cout << "OK\n";
  return 0;
}